<?php

defined('_JEXEC') or die('Restricted access');
jimport('joomla.plugin.helper');

class plgjshoppingcheckoutcheck_tax_for_EU extends JPlugin {
	
	private $errorMsg = '';

    function __construct(&$subject, $config) {
        parent::__construct($subject, $config);
    }

    public function onBeforeSaveCheckoutStep2(&$adv_user) {
        $taxNumber = trim(strval($adv_user->tax_number));
        if (strlen($taxNumber) <= 0) {
            return NULL;
        }
		if (!$this->checkTaxNumber($taxNumber)){
			$url = SEFLink('index.php?option=com_jshopping&controller=checkout&task=step2', 0, 1);			
			JFactory::getApplication()->redirect($url, $this->errorMsg, 'error');
		}
    }
	
	public function onAfterRegister(&$user, &$usershop, &$post, &$useractivation){
		$taxNumber = trim(strval($usershop->tax_number));
		if (!$this->params->get('check_registration') || $taxNumber==''){
			return;
		}
		if (!$this->checkTaxNumber($taxNumber)){
			JError::raiseNotice(111, $this->errorMsg);
		}
	}
	
	function  checkTaxNumber($tax_number){
		$lang = JFactory::getLanguage();
        $lang->load('plg_jshoppingcheckout_check_tax_for_EU', JPATH_ADMINISTRATOR);
		$check = 0;
        $vatid = strval($tax_number);
        $vatid = str_replace(array(' ', '.', '-', ',', ', '), '', trim($vatid));
        $cc = substr($vatid, 0, 2);
        $vn = substr($vatid, 2);
        
        $client = new SoapClient("http://ec.europa.eu/taxation_customs/vies/checkVatService.wsdl");
        
        if ($client) {
            $params = array('countryCode' => $cc, 'vatNumber' => $vn);
            try {
                $r = $client->checkVat($params);

                if ($r->valid == true) {
                    $check = 1;
                } else {
					$check = 0;
                    $this->errorMsg = JText::_('WRONG_FORMAT');
                }
            } catch (SoapFault $e) {
				$check = 0;
                $this->errorMsg = 'Error: '.JText::_(str_replace(' ', '_', $e->faultstring));
            }
        } else {
			$check = 0;
            $this->errorMsg = 'Connection to host not possible, europe.eu';
        }
		return $check;
	}

}